Subject: Re: bug#41802: 28.0.50; eww triggers 100% CPU consumption when opening page with animated gif

From: Alan Third <[email-masked]>
Date: Thu, 11 Jun 2020 22:54:57 +0200 (CEST)

On Thu, Jun 11, 2020 at 03:47:28PM +0200, Jhair Tocancipa Triana wrote:
> I can reproduce the issue with the following steps:
> 
> 1) emacs -Q
> 2) M-x eww RET
> 3) https://github.com/drewbarbs/erc-status-sidebar RET
> 
> After that CPU consumption rises to 100% until I close the eww buffer

Almost certainly this is down to how we handle images.

The gif file is decoded one frame at a time, which is quite
inefficient as to decode frame x, all frames from 0-x must be decoded.

This is normally only a problem for the first run through as we cache
the images, however, if the gif is long enough, by the time we reach
the the last frame the first frames may have already been flushed from
the cache resulting in them having to be decoded again.

There was some discussion of this a little while back and I don't
think we had any workable solution beyond a rewrite of the image code.
-- 
Alan Third